require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AMD64_PMAP_H_)) {
    eval 'sub _AMD64_PMAP_H_ () {1;}' unless defined(&_AMD64_PMAP_H_);
    if(defined(&__x86_64__)) {
	if(defined(&_KERNEL_OPT)) {
	    require './amd64/opt_xen.ph';
	}
	require 'sys/atomic.ph';
	require 'machine/pte.ph';
	require 'machine/segments.ph';
	if(defined(&_KERNEL)) {
	    require 'machine/cpufunc.ph';
	}
	require 'uvm/uvm_object.ph';
	if(defined(&XEN)) {
	    require 'xen/xenfunc.ph';
	    require 'xen/xenpmap.ph';
	}
	eval 'sub VA_SIGN_MASK () {0xffff000000000000;}' unless defined(&VA_SIGN_MASK);
	eval 'sub VA_SIGN_NEG {
	    my($va) = @_;
    	    eval q((($va) |  &VA_SIGN_MASK));
	}' unless defined(&VA_SIGN_NEG);
	eval 'sub VA_SIGN_POS {
	    my($va) = @_;
    	    eval q((($va) & ~ &VA_SIGN_MASK));
	}' unless defined(&VA_SIGN_POS);
	eval 'sub L4_SLOT_PTE () {255;}' unless defined(&L4_SLOT_PTE);
	unless(defined(&XEN)) {
	    eval 'sub L4_SLOT_KERN () {256;}' unless defined(&L4_SLOT_KERN);
	} else {
	    eval 'sub L4_SLOT_KERN () {320;}' unless defined(&L4_SLOT_KERN);
	}
	eval 'sub L4_SLOT_KERNBASE () {511;}' unless defined(&L4_SLOT_KERNBASE);
	eval 'sub PDIR_SLOT_KERN () { &L4_SLOT_KERN;}' unless defined(&PDIR_SLOT_KERN);
	eval 'sub PDIR_SLOT_PTE () { &L4_SLOT_PTE;}' unless defined(&PDIR_SLOT_PTE);
	eval 'sub PTE_BASE () {(( &pt_entry_t *)( &L4_SLOT_PTE *  &NBPD_L4));}' unless defined(&PTE_BASE);
	eval 'sub KERN_BASE () {(( &pt_entry_t *)( &L4_SLOT_KERN *  &NBPD_L4));}' unless defined(&KERN_BASE);
	eval 'sub L1_BASE () { &PTE_BASE;}' unless defined(&L1_BASE);
	eval 'sub L2_BASE () {(( &pd_entry_t *)( &L1_BASE +  &L4_SLOT_PTE *  &NBPD_L3));}' unless defined(&L2_BASE);
	eval 'sub L3_BASE () {(( &pd_entry_t *)( &L2_BASE +  &L4_SLOT_PTE *  &NBPD_L2));}' unless defined(&L3_BASE);
	eval 'sub L4_BASE () {(( &pd_entry_t *)( &L3_BASE +  &L4_SLOT_PTE *  &NBPD_L1));}' unless defined(&L4_BASE);
	eval 'sub PDP_PDE () {( &L4_BASE +  &PDIR_SLOT_PTE);}' unless defined(&PDP_PDE);
	eval 'sub PDP_BASE () { &L4_BASE;}' unless defined(&PDP_BASE);
	eval 'sub NKL4_MAX_ENTRIES () {1;}' unless defined(&NKL4_MAX_ENTRIES);
	eval 'sub NKL3_MAX_ENTRIES () {( &NKL4_MAX_ENTRIES * 512);}' unless defined(&NKL3_MAX_ENTRIES);
	eval 'sub NKL2_MAX_ENTRIES () {( &NKL3_MAX_ENTRIES * 512);}' unless defined(&NKL2_MAX_ENTRIES);
	eval 'sub NKL1_MAX_ENTRIES () {( &NKL2_MAX_ENTRIES * 512);}' unless defined(&NKL1_MAX_ENTRIES);
	eval 'sub NKL4_KIMG_ENTRIES () {1;}' unless defined(&NKL4_KIMG_ENTRIES);
	eval 'sub NKL3_KIMG_ENTRIES () {1;}' unless defined(&NKL3_KIMG_ENTRIES);
	eval 'sub NKL2_KIMG_ENTRIES () {32;}' unless defined(&NKL2_KIMG_ENTRIES);
	eval 'sub NKL4_START_ENTRIES () {0;}' unless defined(&NKL4_START_ENTRIES);
	eval 'sub NKL3_START_ENTRIES () {0;}' unless defined(&NKL3_START_ENTRIES);
	eval 'sub NKL2_START_ENTRIES () {0;}' unless defined(&NKL2_START_ENTRIES);
	eval 'sub NKL1_START_ENTRIES () {0;}' unless defined(&NKL1_START_ENTRIES);
	eval 'sub NTOPLEVEL_PDES () {( &PAGE_SIZE / ($sizeof{ &pd_entry_t}));}' unless defined(&NTOPLEVEL_PDES);
	eval 'sub NPDPG () {( &PAGE_SIZE / $sizeof{ &pd_entry_t});}' unless defined(&NPDPG);
	eval 'sub PTP_MASK_INITIALIZER () {{  &L1_FRAME,  &L2_FRAME,  &L3_FRAME,  &L4_FRAME };}' unless defined(&PTP_MASK_INITIALIZER);
	eval 'sub PTP_SHIFT_INITIALIZER () {{  &L1_SHIFT,  &L2_SHIFT,  &L3_SHIFT,  &L4_SHIFT };}' unless defined(&PTP_SHIFT_INITIALIZER);
	eval 'sub NKPTP_INITIALIZER () {{  &NKL1_START_ENTRIES,  &NKL2_START_ENTRIES,  &NKL3_START_ENTRIES,  &NKL4_START_ENTRIES };}' unless defined(&NKPTP_INITIALIZER);
	eval 'sub NKPTPMAX_INITIALIZER () {{  &NKL1_MAX_ENTRIES,  &NKL2_MAX_ENTRIES,  &NKL3_MAX_ENTRIES,  &NKL4_MAX_ENTRIES };}' unless defined(&NKPTPMAX_INITIALIZER);
	eval 'sub NBPD_INITIALIZER () {{  &NBPD_L1,  &NBPD_L2,  &NBPD_L3,  &NBPD_L4 };}' unless defined(&NBPD_INITIALIZER);
	eval 'sub PDES_INITIALIZER () {{  &L2_BASE,  &L3_BASE,  &L4_BASE };}' unless defined(&PDES_INITIALIZER);
	eval 'sub PTP_LEVELS () {4;}' unless defined(&PTP_LEVELS);
	eval 'sub PG_W () { &PG_AVAIL1;}' unless defined(&PG_W);
	eval 'sub PG_PVLIST () { &PG_AVAIL2;}' unless defined(&PG_PVLIST);
	eval 'sub PG_X () {0;}' unless defined(&PG_X);
	eval 'sub NPTECL () {8;}' unless defined(&NPTECL);
	require 'x86/pmap.ph';
	unless(defined(&XEN)) {
	    eval 'sub pmap_pa2pte {
	        my($a) = @_;
    		eval q(($a));
	    }' unless defined(&pmap_pa2pte);
	    eval 'sub pmap_pte2pa {
	        my($a) = @_;
    		eval q((($a) &  &PG_FRAME));
	    }' unless defined(&pmap_pte2pa);
	    eval 'sub pmap_pte_set {
	        my($p, $n) = @_;
    		eval q( &do { *($p) = ($n); }  &while (0));
	    }' unless defined(&pmap_pte_set);
	    eval 'sub pmap_pte_cas {
	        my($p, $o, $n) = @_;
    		eval q( &atomic_cas_64(($p), ($o), ($n)));
	    }' unless defined(&pmap_pte_cas);
	    eval 'sub pmap_pte_testset {
	        my($p, $n) = @_;
    		eval q( &atomic_swap_ulong(( &volatile \'unsigned long\' *)$p, $n));
	    }' unless defined(&pmap_pte_testset);
	    eval 'sub pmap_pte_setbits {
	        my($p, $b) = @_;
    		eval q( &atomic_or_ulong(( &volatile \'unsigned long\' *)$p, $b));
	    }' unless defined(&pmap_pte_setbits);
	    eval 'sub pmap_pte_clearbits {
	        my($p, $b) = @_;
    		eval q( &atomic_and_ulong(( &volatile \'unsigned long\' *)$p, ~($b)));
	    }' unless defined(&pmap_pte_clearbits);
	    eval 'sub pmap_pte_flush () {
	        eval q();
	    }' unless defined(&pmap_pte_flush);
	} else {
	    eval 'sub pmap_pa2pte {
	        my($pa) = @_;
    		eval q({ ( &pt_entry_t) &xpmap_ptom_masked($pa); });
	    }' unless defined(&pmap_pa2pte);
	    eval 'sub pmap_pte2pa {
	        my($pte) = @_;
    		eval q({  &xpmap_mtop_masked($pte &  &PG_FRAME); });
	    }' unless defined(&pmap_pte2pa);
	    eval 'sub pmap_pte_set {
	        my($pte,$npte) = @_;
    		eval q({ \'int\'  &s =  &splvm();  &xpq_queue_pte_update( &xpmap_ptetomach($pte), $npte);  &splx( &s); });
	    }' unless defined(&pmap_pte_set);
	    eval 'sub pmap_pte_cas {
	        my($ptep,$o,$n) = @_;
    		eval q({  &pt_entry_t  &opte;  &mutex_enter( &pte_lock);  &opte = *$ptep;  &if ( &opte == $o) {  &xpq_queue_pte_update( &xpmap_ptetomach( &__UNVOLATILE($ptep)), $n);  &xpq_flush_queue(); }  &mutex_exit( &pte_lock);  &opte; });
	    }' unless defined(&pmap_pte_cas);
	    eval 'sub pmap_pte_testset {
	        my($pte,$npte) = @_;
    		eval q({  &pt_entry_t  &opte;  &mutex_enter( &pte_lock);  &opte = *$pte;  &xpq_queue_pte_update( &xpmap_ptetomach( &__UNVOLATILE($pte)), $npte);  &xpq_flush_queue();  &mutex_exit( &pte_lock);  &opte; });
	    }' unless defined(&pmap_pte_testset);
	    eval 'sub pmap_pte_setbits {
	        my($pte,$bits) = @_;
    		eval q({  &mutex_enter( &pte_lock);  &xpq_queue_pte_update( &xpmap_ptetomach( &__UNVOLATILE($pte)), (*$pte) | $bits);  &xpq_flush_queue();  &mutex_exit( &pte_lock); });
	    }' unless defined(&pmap_pte_setbits);
	    eval 'sub pmap_pte_clearbits {
	        my($pte,$bits) = @_;
    		eval q({  &mutex_enter( &pte_lock);  &xpq_queue_pte_update( &xpmap_ptetomach( &__UNVOLATILE($pte)), (*$pte) & ~$bits);  &xpq_flush_queue();  &mutex_exit( &pte_lock); });
	    }' unless defined(&pmap_pte_clearbits);
	    eval 'sub pmap_pte_flush {
	        my($void) = @_;
    		eval q({ \'int\'  &s =  &splvm();  &xpq_flush_queue();  &splx( &s); });
	    }' unless defined(&pmap_pte_flush);
	}
	require 'x86/pmap_pv.ph';
	eval 'sub __HAVE_VM_PAGE_MD () {1;}' unless defined(&__HAVE_VM_PAGE_MD);
	eval 'sub VM_MDPAGE_INIT {
	    my($pg) = @_;
    	    eval q( &memset(($pg)-> &mdpage, 0, $sizeof{($pg)-> &mdpage});  &PMAP_PAGE_INIT(($pg)-> ($mdpage->{mp_pp})));
	}' unless defined(&VM_MDPAGE_INIT);
    } else {
	require 'i386/pmap.ph';
    }
}
1;
